#ifndef Caservertestqt_H
#define Caservertestqt_H

#include <QWidget>
#include <QMultiMap>

class QTreeWidgetItem;
class QTimer;
class CaSerTestReader;

// cumbia
#include <qulogimpl.h>
#include <cucontrolsfactorypool.h>
class CumbiaPool;
class CuData;
// cumbia

namespace Ui {
class Caservertestqt;
}

class Caservertestqt_P {
public:
    Caservertestqt_P();

    enum Counters { CounterSub, CounterUnsub };
    void reset_counters();

    QString srclistfile;
    QMultiMap<int, QString> srcmap;
    QMap<int, uint> counters;
    QMultiMap<double, QTreeWidgetItem*> running_creat_src_map;
    QTimer *subscribe_tmr, *timer_sec;
    long filesrc_siz;

    QColor err_bg;
};

class Caservertestqt : public QWidget
{
    Q_OBJECT

    enum RunningViewCols { ColDataSrc = 0, ColDataStarted, ColDataElapsed,
                           ColDataUpdated, ColDataValue, ColDataEvent, ColDataErr,
                           ColDataMsg, ColDataSrcId };


    enum SrcPoolViewCols { SrcPoolN, SrcPoolSrcNam, SrcPoolId };

    enum UserData { Data_Creat_US = Qt::UserRole + 1, Data_Src_Id, Data_Stop_Sec,
                    Data_Updated_DateTime, DataOkFlag };

public:
    explicit Caservertestqt(CumbiaPool *cu_p, QWidget *parent, const QString &srclistfile);
    ~Caservertestqt();

protected slots:
    void start();
    void stop();

    void onMainTimeout();
    void onTimeoutSec();

    void onNewData(double creat_us, const CuData& da);

    void loadPool();

private:
    Ui::Caservertestqt *ui;

    // cumbia
    CumbiaPool *cu_pool;
    QuLogImpl m_log_impl;
    CuControlsFactoryPool m_ctrl_factory_pool;
    // cumbia

    Caservertestqt_P *d;

    CaSerTestReader* m_start_reader(const QString& src, ulong id);
    void m_stop_reader();
    QString m_make_reader_nam(const QString& src, double creat_us, long id) const;
    QTreeWidgetItem *m_clone_item(const QTreeWidgetItem *it) const;

    void m_save_settings();
    void m_load_settings();
};

#endif // Caservertestqt_H
