#include <quapplication.h>
#include "caserver-test-qt.h"

// cumbia
#include <QCommandLineParser>
#include <cumbiapool.h>
#include <cuthreadfactoryimpl.h>
#include <qthreadseventbridgefactory.h>
// cumbia

#define VERSION "1.0"

int main(int argc, char *argv[])
{
    QuApplication qu_app( argc, argv );
    qu_app.setOrganizationName("Elettra");
    qu_app.setApplicationName("Caservertestqt");
    QString version(VERSION);
    qu_app.setApplicationVersion(version);
    qu_app.setProperty("author", "Giacomo");
    qu_app.setProperty("mail", "giacomo.strangolino@elettra.eu");
    qu_app.setProperty("phone", "0403758073");
    qu_app.setProperty("office", "T2PT025");
    qu_app.setProperty("hwReferent", "$HW_REFERENT$"); /* name of the referent that provides the device server */
    
    int ret = 1;
    // load srcs
    QCommandLineParser p;
    p.addHelpOption();
    QCommandLineOption srcf(QStringList() << "f" << "src-file",
                                       "File containing the sources list, one per line",
                                       "file");
    p.addOption(srcf);
    p.parse(qApp->arguments());

    if(p.isSet(srcf)) {
        printf("parsing file %s\n", qstoc(p.value(srcf)));
        CumbiaPool *cu_p = new CumbiaPool();
        Caservertestqt *w = new Caservertestqt(cu_p, NULL, p.value(srcf));
        w->show();
        // exec application loop
        ret = qu_app.exec();
        // delete resources and return
        delete w;

        for(std::string n : cu_p->names())
            if(cu_p->get(n))
                delete cu_p->get(n);
    }
    else {
        perr("Usage %s src-list-file.txt", qstoc(qApp->arguments().first()));


    }

    return ret;
}
